/*
 * Parses a URL into components into a structure
 */

#ifndef URL_PARSER
#define URL_PARSER

typedef struct {
  String protocol = "";
  String host = "";
  String port = "";
  String path = "";
} URL_STRUCT;


// Parse a URL into component parts
void parseURL(String urlString, URL_STRUCT *urlStruct) {

  enum URLParseState { PROTOCOL,
                       SEPERATOR,
                       HOST,
                       PORT,
                       PATH };
  URLParseState state = PROTOCOL;

  urlStruct->protocol = "";
  urlStruct->host = "";
  urlStruct->port = "";
  urlStruct->path = "/";

  for (int i = 0; i < urlString.length(); i++) {

    switch (state) {

      case PROTOCOL:
        if (urlString[i] == ':') {
          state = SEPERATOR;
        } else {
          urlStruct->protocol += urlString[i];
        }
        break;

      case SEPERATOR:
        if (urlString[i] != '/') {
          state = HOST;
          urlStruct->host += urlString[i];
        }
        break;

      case HOST:
        if (urlString[i] == ':') {
          state = PORT;
        } else {
          if (urlString[i] == '/') {
            state = PATH;
          } else {
            urlStruct->host += urlString[i];
          }
        }
        break;

      case PORT:
        if (urlString[i] == '/') {
          state = PATH;
        } else {
          urlStruct->port += urlString[i];
        }
        break;

      case PATH:
        urlStruct->path += urlString[i];
        break;
    }
  }
}

#endif
